// plastic surgery
precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D sTexture1;
uniform vec2 uTextureSize;

void main() {
    vec4 c4 = texture2D(sTexture1, vTextureCoord);
    float dx = 1.0 / uTextureSize.x;
    float dy = 1.0 / uTextureSize.y;
    vec2 coordl = vec2(vTextureCoord.x-dx, vTextureCoord.y);
    vec2 coordr = vec2(vTextureCoord.x+dx, vTextureCoord.y);
    vec2 coordt = vec2(vTextureCoord.x, vTextureCoord.y-dy);
    vec2 coordb = vec2(vTextureCoord.x, vTextureCoord.y+dy);
    vec2 coordtl = vec2(vTextureCoord.x-dx, vTextureCoord.y-dy);
    vec2 coordtr = vec2(vTextureCoord.x+dx, vTextureCoord.y-dy);
    vec2 coordbl = vec2(vTextureCoord.x-dx, vTextureCoord.y+dy);
    vec2 coordbr = vec2(vTextureCoord.x+dx, vTextureCoord.y+dy);
    
    vec4 cl = texture2D(sTexture1, coordl);
    vec4 cr = texture2D(sTexture1, coordr);
    vec4 ct = texture2D(sTexture1, coordt);
    vec4 cb = texture2D(sTexture1, coordb);
    vec4 ctl = texture2D(sTexture1, coordtl);
    vec4 ctr = texture2D(sTexture1, coordtr);
    vec4 cbl = texture2D(sTexture1, coordbl);
    vec4 cbr = texture2D(sTexture1, coordbr);
    
    vec4 fSumX = -1.0 * ctl + 1.0 * ctr - 2.0 * cl + 2.0 * cr - 1.0 * cbl + 1.0 * cbr;
    vec4 fSumY =  1.0 * ctl + 2.0 * ct + 1.0 * ctr - 1.0 * cbl - 2.0 * cb - 1.0 * cbr;
    vec4 fSum = sqrt(fSumX * fSumX + fSumY * fSumY);
    fSum = mix(fSum, c4, 0.7);

    gl_FragColor = fSum;
}
